//+------------------------------------------------------------------+
//|                                          Bollinger %b - Multi.mq4 |
//|                                   based on Bollinger Bands %b.mq4 |
//|                           Original indicator by Alejandro Galindo |
//|                  Modified and Corrected by Linuxser for forex TSD |
//|                  Further modifications made by whitebloodcell     |
//| 
//|  John Bollinger original formula is:                              |
//| (Last - Lower BB)/(Upper BB - Lower BB)                           |
//+-------------------------------------------------------------------+
#property copyright ""
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 LightSalmon
#property indicator_color2 LightSalmon  
#property indicator_color3 SkyBlue
#property indicator_color4 SkyBlue
#property indicator_color5 LightGreen
#property indicator_color6 LightGreen        
  
/*
Constant Value Description 
MODE_SMA 0 Simple moving average, 
MODE_EMA 1 Exponential moving average, 
MODE_SMMA 2 Smoothed moving average, 
MODE_LWMA 3 Linear weighted moving average. 
*/
//---- input parameters
extern bool   ShowBand1 = TRUE;
extern int    Timeframe_1 = 0;
extern int    BBLength_1=5;
extern int    BandMAMethod_1 = 1;
extern double StdDeviation_1=1.9;
extern int    AppliedPrice_1=0;
extern int    MainLineMAPeriod_1=1;
extern int    MainLineMAMethod_1=1;
extern int    SignalMAPeriod_1=2;//corresponds to %D - the signal line
extern int    SignalMAMethod_1=1;

extern bool   ShowBand2 = TRUE;
extern int    Timeframe_2 = 0;
extern int    BBLength_2=10;
extern int    BandMAMethod_2=1;
extern double StdDeviation_2=2;
extern int    AppliedPrice_2=0;
extern int    MainLineMAPeriod_2=2;
extern int    MainLineMAMethod_2=1;
extern int    SignalMAPeriod_2=3;
extern int    SignalMAMethod_2=1;

extern bool   ShowBand3 = TRUE;
extern int    Timeframe_3 = 0;
extern int    BBLength_3=20;
extern int    BandMAMethod_3=1;
extern double StdDeviation_3=2.0;
extern int    AppliedPrice_3=0;
extern int    MainLineMAPeriod_3=2;
extern int    MainLineMAMethod_3=1;
extern int    SignalMAPeriod_3=3;
extern int    SignalMAMethod_3=1;

extern int    AppliedPrice=0;
extern string s2 = "0=SMA,1=EMA,2=Smoothed,4=LWMA";  
extern string s1 = "0=Close,1=Open,2=High,3=Low,4=Median,5=Typical,6=Weighted";

string sSymbol="";
//---- buffers
double BLG_Buffer_1[];
double MainLineBuffer_1[];
double SignalBuffer_1[];
double MABuffer_1[];
double UpperBandBuffer_1[];
double LowerBandBuffer_1[];

double BLG_Buffer_2[];
double MainLineBuffer_2[];
double SignalBuffer_2[];
double MABuffer_2[];
double UpperBandBuffer_2[];
double LowerBandBuffer_2[];

double BLG_Buffer_3[];
double MainLineBuffer_3[];
double SignalBuffer_3[];
double MABuffer_3[];
double UpperBandBuffer_3[];
double LowerBandBuffer_3[];
//#include <JJMASeries.mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   string short_name;
   sSymbol = Symbol();
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(0,MainLineBuffer_1);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(1,SignalBuffer_1); 

   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(2,MainLineBuffer_2);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(3,SignalBuffer_2);
   
   SetIndexStyle(4,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(4,MainLineBuffer_3);
   SetIndexStyle(5,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(5,SignalBuffer_3);
   
   //SetLevelValue(1,10);
   SetLevelValue(0,0);
   SetLevelValue(1,20);
   SetLevelValue(2,40);
   SetLevelValue(3,60);
   SetLevelValue(4,80);
   SetLevelValue(5,100);
   SetLevelStyle(STYLE_DOT,1,DimGray);
   
   SetIndexDrawBegin(0,BBLength_1);
   SetIndexDrawBegin(1,BBLength_1+SignalMAPeriod_1);
   SetIndexDrawBegin(2,BBLength_2);
   SetIndexDrawBegin(3,BBLength_2+SignalMAPeriod_2);
   SetIndexDrawBegin(4,BBLength_3);
   SetIndexDrawBegin(5,BBLength_3+SignalMAPeriod_3);

   //Choose shortname based on what options are selected above.
   if(ShowBand1==TRUE && ShowBand2==FALSE && ShowBand3==FALSE) {
      short_name="Bollinger Percent B (%b)("+BBLength_1+","+MainLineMAPeriod_1+")";
   }
   else if(ShowBand1==TRUE && ShowBand2==TRUE && ShowBand3==FALSE) {
      short_name="Bollinger Percent B (%b)("+BBLength_1+","+MainLineMAPeriod_1+") ("+BBLength_2+","+MainLineMAPeriod_2+")";
   }
   else if(ShowBand1==TRUE && ShowBand2==TRUE && ShowBand3==TRUE) {
      short_name="Bollinger Percent B (%b)("+BBLength_1+","+MainLineMAPeriod_1+") ("+BBLength_2+","+MainLineMAPeriod_2+") ("+BBLength_3+","+MainLineMAPeriod_3+")";
   }
   IndicatorShortName(short_name);  
   return(0);
}
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start() {

   if(ShowBand1==TRUE) {
      if(Bars<=BBLength_1) return(0);
      MainFunction(sSymbol, BLG_Buffer_1, MainLineBuffer_1, SignalBuffer_1, MABuffer_1, UpperBandBuffer_1, LowerBandBuffer_1,  
                   Timeframe_1, BBLength_1, BandMAMethod_1, StdDeviation_1, AppliedPrice_1, MainLineMAPeriod_1, 
                   MainLineMAMethod_1, SignalMAPeriod_1, SignalMAMethod_1);
   }                                    
   if(ShowBand2==TRUE) {
      if(Bars<=BBLength_2) return(0);
      MainFunction(sSymbol, BLG_Buffer_2, MainLineBuffer_2, SignalBuffer_2, MABuffer_2, UpperBandBuffer_2, LowerBandBuffer_2, 
                   Timeframe_2, BBLength_2, BandMAMethod_2, StdDeviation_2, AppliedPrice_2, MainLineMAPeriod_2, 
                   MainLineMAMethod_2, SignalMAPeriod_2, SignalMAMethod_2);
   }            
   if(ShowBand3==TRUE) {
      if(Bars<=BBLength_3) return(0);
      MainFunction(sSymbol, BLG_Buffer_3, MainLineBuffer_3, SignalBuffer_3, MABuffer_3, UpperBandBuffer_3, LowerBandBuffer_3, 
                   Timeframe_3, BBLength_3, BandMAMethod_3, StdDeviation_3, AppliedPrice_3, MainLineMAPeriod_3, 
                   MainLineMAMethod_3, SignalMAPeriod_3, SignalMAMethod_3);
   }         
      return(0);
}

//--------------------------------------------------------------------------------
//Function: BandCalculation - Not yet working
//Purpose:  Calculate the value of either the upper or lower bollinger band depen-
//          on input variables. 
//Inputs:   Mode (int) - Calculate either upper or lower band
//          limit (int) - Number of bars to calculate
//          timeframe (int)
//          BandsPeriod (int)
//          MAMethod (int)
//          BandsDeviation (double)
//          AppliedPrice (int)   
//Returns:  
//--------------------------------------------------------------------------------
void MainFunction(string _Symbol, double &BLGBuffer[], double &MainLineBuffer[], double &SignalBuffer[], double &MABuffer[], 
                  double &UpperBandBuffer[], double &LowerBandBuffer[], int _Timeframe, int BBLength, 
                  int BandMAMethod, double BandDeviation, int AppliedPrice, int MainLineMAPeriod, int MainLineMAMethod, int SignalMAPeriod, int SignalMAMethod) {
   int i=0,k=0,limit=0;
   double sum,ma;
   double PriceArray[];
   
   if(ArrayRange(BLGBuffer,0) != Bars) {
      ArrayResize(BLGBuffer,Bars);
      ArraySetAsSeries(BLGBuffer, TRUE); 
   }
   if(ArrayRange(MABuffer,0) != Bars) {
      ArrayResize(MABuffer,Bars);
      ArraySetAsSeries(MABuffer, TRUE); 
   }
   if(ArrayRange(UpperBandBuffer,0) != Bars) {
      ArrayResize(UpperBandBuffer,Bars);
      ArraySetAsSeries(UpperBandBuffer, TRUE); 
   }
   if(ArrayRange(LowerBandBuffer,0) != Bars) {
      ArrayResize(LowerBandBuffer,Bars);
      ArraySetAsSeries(LowerBandBuffer, TRUE); 
   }         
   //number of bars already processed by indicator
   int counted_bars=IndicatorCounted();
   
   //load empty values into array until enough elements for calculation
   if(counted_bars<1) {
      for(i=1;i<=BBLength;i++) {
         BLGBuffer[Bars-i]=EMPTY_VALUE;
      }//end for(i=1;i<=BandsPeriod;i++)
   }//end if(counted_bars<1)    
   
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-BBLength);
   
   for(i=limit;i>=0;i--) {  
      ma = iMA(NULL,_Timeframe,BBLength,0,BandMAMethod,AppliedPrice,i);
            for(sum = 0.0, k = 0; k < BBLength; k++) {
               sum += ((iClose(_Symbol,_Timeframe,k+i)-ma)*(iClose(_Symbol,_Timeframe,k+i)-ma));
            }     
      
      MABuffer[i] = ma;
      if (BandDeviation!=0) {
            UpperBandBuffer[i]  = ma+BandDeviation*MathSqrt(sum/BBLength);
            LowerBandBuffer[i]  = ma-BandDeviation*MathSqrt(sum/BBLength);
      }//if (BandDeviation!=0)               
      
      BLGBuffer[i]=((iClose(_Symbol,_Timeframe,i)-LowerBandBuffer[i])/
                    (UpperBandBuffer[i]-LowerBandBuffer[i]))*100;
      
      //(Last - Lower BB)/(Upper BB - Lower BB)      
      //BLGBuffer[i]=((Close[i] - iBands(NULL,_Timeframe,BBPeriod,BandDeviation,0,AppliedPrice,MODE_LOWER,i))/
      //(iBands(NULL,timefame,BBPeriod,BandDeviation,0,AppliedPrice,MODE_UPPER,i)-iBands(NULL,timefame,BBPeriod,BandDeviation,0,AppliedPrice,MODE_LOWER,i)))*100;
   }//end for(i=limit;i>=0;i--)
  
         
         
   //smooth the signal by applying a moving average
   for (i = limit; i >= 0; i--) MainLineBuffer[i] = iMAOnArray(BLGBuffer, 0, MainLineMAPeriod, 0, MainLineMAMethod, i);
   //create a Signal line (akin to stochastics) by further smoothing the (already smoothed) signal line.
   for (i = limit; i >= 0; i--) SignalBuffer[i] = iMAOnArray(MainLineBuffer, 0, SignalMAPeriod, 0, SignalMAMethod, i);  

}//end MainFunction()   







